<?php
/**
 * @author Daniel Knudsen <d.knudsen@spawntree.de>
 * @date 12.12.23
 */


namespace App\ApiResource;

use ApiPlatform\Doctrine\Orm\Filter\OrderFilter;
use ApiPlatform\Doctrine\Orm\Filter\SearchFilter;
use ApiPlatform\Doctrine\Orm\State\Options;
use ApiPlatform\Metadata\ApiFilter;
use ApiPlatform\Metadata\ApiProperty;
use ApiPlatform\Metadata\ApiResource;
use App\Entity\UserProduct;
use App\Interface\OwnerInterface;
use App\State\EntityClassDtoStateProcessor;
use App\State\EntityToDtoStateProvider;
use ApiPlatform\Metadata\Delete;
use ApiPlatform\Metadata\Get;
use ApiPlatform\Metadata\GetCollection;
use ApiPlatform\Metadata\Post;
use Symfony\Component\PropertyInfo\Type;
use Symfony\Component\Validator\Constraints\NotBlank;

#[ApiResource(
    shortName: 'UserProduct',
    operations: [
        new Get(
            security: 'is_granted("ROLE_USER")',
        ),
        new GetCollection(
            security: 'is_granted("ROLE_USER")',
        ),
        new Post(
            security: 'is_granted("ROLE_USER")',
        ),
        new Delete(
            security: 'is_granted("EDIT", object)',
        )
    ],
    security: 'is_granted("ROLE_USER")',
    provider: EntityToDtoStateProvider::class,
    processor: EntityClassDtoStateProcessor::class,
    stateOptions: new Options(entityClass: UserProduct::class),
)]
#[ApiFilter(SearchFilter::class, properties: ['user' => 'exact', 'product' => 'exact'])]
#[ApiFilter(OrderFilter::class, properties: ['product.name'], arguments: ['orderParameterName' => 'order'])]
class UserProductApi implements OwnerInterface
{
    #[ApiProperty(readable: false, writable: false, identifier: true)]
    public ?int $id = null;

    #[ApiProperty(writable: false)]
    public ?UserApi $user = null;

    #[ApiProperty(writable: false)]
    public ?string $userName = null;

    #[NotBlank]
    /**
     * @var $product ?ProductApi
     */
    #[ApiProperty(
        writable: true,
        readableLink: true,
        writableLink: true,
        builtinTypes: [
            new Type(
                'object',
                class: ProductApi::class,
            )
        ]
    )]
    public ?ProductApi $product = null;

    #[ApiProperty(writable: false)]
    public ?string $productName = null;

    #[ApiProperty(writable: false)]
    public ?\DateTimeImmutable $createdAt = null;

    public function getOwner(): ?UserApi
    {
        return $this->user;
    }
}